// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.28.1
// 	protoc        v3.18.1
// source: arrays/array_service.proto

package arrays

import (
	data "gitlab.com/skllzz/jmot/gojmot-client/pb/keeper/data"
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

// запрос на чтение данных массива
type ReadRequest struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// имя массива
	ArrayName string `protobuf:"bytes,1,opt,name=array_name,json=arrayName,proto3" json:"array_name,omitempty"`
	// размер единичной порции элементов, если меньше или равно 0 то используется значение по умолчанию
	PageSize int32 `protobuf:"varint,2,opt,name=page_size,json=pageSize,proto3" json:"page_size,omitempty"`
	// режим ожидания появление новых данных после получения последнего элемента
	Continuous bool `protobuf:"varint,3,opt,name=continuous,proto3" json:"continuous,omitempty"`
	// диапазон выборки
	Range *data.IdRange `protobuf:"bytes,4,opt,name=range,proto3" json:"range,omitempty"`
}

func (x *ReadRequest) Reset() {
	*x = ReadRequest{}
	if protoimpl.UnsafeEnabled {
		mi := &file_arrays_array_service_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *ReadRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRequest) ProtoMessage() {}

func (x *ReadRequest) ProtoReflect() protoreflect.Message {
	mi := &file_arrays_array_service_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRequest.ProtoReflect.Descriptor instead.
func (*ReadRequest) Descriptor() ([]byte, []int) {
	return file_arrays_array_service_proto_rawDescGZIP(), []int{0}
}

func (x *ReadRequest) GetArrayName() string {
	if x != nil {
		return x.ArrayName
	}
	return ""
}

func (x *ReadRequest) GetPageSize() int32 {
	if x != nil {
		return x.PageSize
	}
	return 0
}

func (x *ReadRequest) GetContinuous() bool {
	if x != nil {
		return x.Continuous
	}
	return false
}

func (x *ReadRequest) GetRange() *data.IdRange {
	if x != nil {
		return x.Range
	}
	return nil
}

// запрос на изменение данных в массиве
type AppendRequest struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// имя массива
	ArrayName string `protobuf:"bytes,1,opt,name=array_name,json=arrayName,proto3" json:"array_name,omitempty"`
	// добавляемый или обновляемый элемент (для удаления элемента следует установить аттрибут Deleted в true)
	Item *data.Item `protobuf:"bytes,2,opt,name=item,proto3" json:"item,omitempty"`
	// добавлять только в случае если такого элемента нет
	IfNotExists bool `protobuf:"varint,3,opt,name=if_not_exists,json=ifNotExists,proto3" json:"if_not_exists,omitempty"`
}

func (x *AppendRequest) Reset() {
	*x = AppendRequest{}
	if protoimpl.UnsafeEnabled {
		mi := &file_arrays_array_service_proto_msgTypes[1]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *AppendRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*AppendRequest) ProtoMessage() {}

func (x *AppendRequest) ProtoReflect() protoreflect.Message {
	mi := &file_arrays_array_service_proto_msgTypes[1]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use AppendRequest.ProtoReflect.Descriptor instead.
func (*AppendRequest) Descriptor() ([]byte, []int) {
	return file_arrays_array_service_proto_rawDescGZIP(), []int{1}
}

func (x *AppendRequest) GetArrayName() string {
	if x != nil {
		return x.ArrayName
	}
	return ""
}

func (x *AppendRequest) GetItem() *data.Item {
	if x != nil {
		return x.Item
	}
	return nil
}

func (x *AppendRequest) GetIfNotExists() bool {
	if x != nil {
		return x.IfNotExists
	}
	return false
}

// запрос на атомарное изменение порции данных в массиве
type AppendMultipleRequest struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	Ops []*AppendRequest `protobuf:"bytes,1,rep,name=ops,proto3" json:"ops,omitempty"`
}

func (x *AppendMultipleRequest) Reset() {
	*x = AppendMultipleRequest{}
	if protoimpl.UnsafeEnabled {
		mi := &file_arrays_array_service_proto_msgTypes[2]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *AppendMultipleRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*AppendMultipleRequest) ProtoMessage() {}

func (x *AppendMultipleRequest) ProtoReflect() protoreflect.Message {
	mi := &file_arrays_array_service_proto_msgTypes[2]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use AppendMultipleRequest.ProtoReflect.Descriptor instead.
func (*AppendMultipleRequest) Descriptor() ([]byte, []int) {
	return file_arrays_array_service_proto_rawDescGZIP(), []int{2}
}

func (x *AppendMultipleRequest) GetOps() []*AppendRequest {
	if x != nil {
		return x.Ops
	}
	return nil
}

// Запрос чтения единичного элемента журнала
type ValueRequest struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// имя массива
	ArrayName string `protobuf:"bytes,1,opt,name=array_name,json=arrayName,proto3" json:"array_name,omitempty"`
	// уникальный идентификатор элемента
	Id string `protobuf:"bytes,2,opt,name=id,proto3" json:"id,omitempty"`
}

func (x *ValueRequest) Reset() {
	*x = ValueRequest{}
	if protoimpl.UnsafeEnabled {
		mi := &file_arrays_array_service_proto_msgTypes[3]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *ValueRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ValueRequest) ProtoMessage() {}

func (x *ValueRequest) ProtoReflect() protoreflect.Message {
	mi := &file_arrays_array_service_proto_msgTypes[3]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ValueRequest.ProtoReflect.Descriptor instead.
func (*ValueRequest) Descriptor() ([]byte, []int) {
	return file_arrays_array_service_proto_rawDescGZIP(), []int{3}
}

func (x *ValueRequest) GetArrayName() string {
	if x != nil {
		return x.ArrayName
	}
	return ""
}

func (x *ValueRequest) GetId() string {
	if x != nil {
		return x.Id
	}
	return ""
}

var File_arrays_array_service_proto protoreflect.FileDescriptor

var file_arrays_array_service_proto_rawDesc = []byte{
	0x0a, 0x1a, 0x61, 0x72, 0x72, 0x61, 0x79, 0x73, 0x2f, 0x61, 0x72, 0x72, 0x61, 0x79, 0x5f, 0x73,
	0x65, 0x72, 0x76, 0x69, 0x63, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x06, 0x61, 0x72,
	0x72, 0x61, 0x79, 0x73, 0x1a, 0x1b, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f,
	0x74, 0x6f, 0x62, 0x75, 0x66, 0x2f, 0x65, 0x6d, 0x70, 0x74, 0x79, 0x2e, 0x70, 0x72, 0x6f, 0x74,
	0x6f, 0x1a, 0x0f, 0x64, 0x61, 0x74, 0x61, 0x2f, 0x69, 0x74, 0x65, 0x6d, 0x2e, 0x70, 0x72, 0x6f,
	0x74, 0x6f, 0x22, 0x8e, 0x01, 0x0a, 0x0b, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x71, 0x75, 0x65,
	0x73, 0x74, 0x12, 0x1d, 0x0a, 0x0a, 0x61, 0x72, 0x72, 0x61, 0x79, 0x5f, 0x6e, 0x61, 0x6d, 0x65,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x09, 0x61, 0x72, 0x72, 0x61, 0x79, 0x4e, 0x61, 0x6d,
	0x65, 0x12, 0x1b, 0x0a, 0x09, 0x70, 0x61, 0x67, 0x65, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x18, 0x02,
	0x20, 0x01, 0x28, 0x05, 0x52, 0x08, 0x70, 0x61, 0x67, 0x65, 0x53, 0x69, 0x7a, 0x65, 0x12, 0x1e,
	0x0a, 0x0a, 0x63, 0x6f, 0x6e, 0x74, 0x69, 0x6e, 0x75, 0x6f, 0x75, 0x73, 0x18, 0x03, 0x20, 0x01,
	0x28, 0x08, 0x52, 0x0a, 0x63, 0x6f, 0x6e, 0x74, 0x69, 0x6e, 0x75, 0x6f, 0x75, 0x73, 0x12, 0x23,
	0x0a, 0x05, 0x72, 0x61, 0x6e, 0x67, 0x65, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0d, 0x2e,
	0x64, 0x61, 0x74, 0x61, 0x2e, 0x49, 0x64, 0x52, 0x61, 0x6e, 0x67, 0x65, 0x52, 0x05, 0x72, 0x61,
	0x6e, 0x67, 0x65, 0x22, 0x72, 0x0a, 0x0d, 0x41, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x52, 0x65, 0x71,
	0x75, 0x65, 0x73, 0x74, 0x12, 0x1d, 0x0a, 0x0a, 0x61, 0x72, 0x72, 0x61, 0x79, 0x5f, 0x6e, 0x61,
	0x6d, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x09, 0x61, 0x72, 0x72, 0x61, 0x79, 0x4e,
	0x61, 0x6d, 0x65, 0x12, 0x1e, 0x0a, 0x04, 0x69, 0x74, 0x65, 0x6d, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x0a, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x2e, 0x49, 0x74, 0x65, 0x6d, 0x52, 0x04, 0x69,
	0x74, 0x65, 0x6d, 0x12, 0x22, 0x0a, 0x0d, 0x69, 0x66, 0x5f, 0x6e, 0x6f, 0x74, 0x5f, 0x65, 0x78,
	0x69, 0x73, 0x74, 0x73, 0x18, 0x03, 0x20, 0x01, 0x28, 0x08, 0x52, 0x0b, 0x69, 0x66, 0x4e, 0x6f,
	0x74, 0x45, 0x78, 0x69, 0x73, 0x74, 0x73, 0x22, 0x40, 0x0a, 0x15, 0x41, 0x70, 0x70, 0x65, 0x6e,
	0x64, 0x4d, 0x75, 0x6c, 0x74, 0x69, 0x70, 0x6c, 0x65, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74,
	0x12, 0x27, 0x0a, 0x03, 0x6f, 0x70, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e,
	0x61, 0x72, 0x72, 0x61, 0x79, 0x73, 0x2e, 0x41, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x52, 0x65, 0x71,
	0x75, 0x65, 0x73, 0x74, 0x52, 0x03, 0x6f, 0x70, 0x73, 0x22, 0x3d, 0x0a, 0x0c, 0x56, 0x61, 0x6c,
	0x75, 0x65, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x12, 0x1d, 0x0a, 0x0a, 0x61, 0x72, 0x72,
	0x61, 0x79, 0x5f, 0x6e, 0x61, 0x6d, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x09, 0x61,
	0x72, 0x72, 0x61, 0x79, 0x4e, 0x61, 0x6d, 0x65, 0x12, 0x0e, 0x0a, 0x02, 0x69, 0x64, 0x18, 0x02,
	0x20, 0x01, 0x28, 0x09, 0x52, 0x02, 0x69, 0x64, 0x32, 0xd6, 0x01, 0x0a, 0x08, 0x4f, 0x70, 0x65,
	0x72, 0x61, 0x74, 0x6f, 0x72, 0x12, 0x29, 0x0a, 0x04, 0x52, 0x65, 0x61, 0x64, 0x12, 0x13, 0x2e,
	0x61, 0x72, 0x72, 0x61, 0x79, 0x73, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x71, 0x75, 0x65,
	0x73, 0x74, 0x1a, 0x0a, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x2e, 0x49, 0x74, 0x65, 0x6d, 0x30, 0x01,
	0x12, 0x2b, 0x0a, 0x06, 0x41, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x12, 0x15, 0x2e, 0x61, 0x72, 0x72,
	0x61, 0x79, 0x73, 0x2e, 0x41, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73,
	0x74, 0x1a, 0x0a, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x2e, 0x49, 0x74, 0x65, 0x6d, 0x12, 0x47, 0x0a,
	0x0e, 0x41, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x4d, 0x75, 0x6c, 0x74, 0x69, 0x70, 0x6c, 0x65, 0x12,
	0x1d, 0x2e, 0x61, 0x72, 0x72, 0x61, 0x79, 0x73, 0x2e, 0x41, 0x70, 0x70, 0x65, 0x6e, 0x64, 0x4d,
	0x75, 0x6c, 0x74, 0x69, 0x70, 0x6c, 0x65, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x16,
	0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66,
	0x2e, 0x45, 0x6d, 0x70, 0x74, 0x79, 0x12, 0x29, 0x0a, 0x05, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x12,
	0x14, 0x2e, 0x61, 0x72, 0x72, 0x61, 0x79, 0x73, 0x2e, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x52, 0x65,
	0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x0a, 0x2e, 0x64, 0x61, 0x74, 0x61, 0x2e, 0x49, 0x74, 0x65,
	0x6d, 0x42, 0x37, 0x5a, 0x35, 0x67, 0x69, 0x74, 0x6c, 0x61, 0x62, 0x2e, 0x63, 0x6f, 0x6d, 0x2f,
	0x73, 0x6b, 0x6c, 0x6c, 0x7a, 0x7a, 0x2f, 0x6a, 0x6d, 0x6f, 0x74, 0x2f, 0x67, 0x6f, 0x6a, 0x6d,
	0x6f, 0x74, 0x2d, 0x63, 0x6c, 0x69, 0x65, 0x6e, 0x74, 0x2f, 0x70, 0x62, 0x2f, 0x6b, 0x65, 0x65,
	0x70, 0x65, 0x72, 0x2f, 0x61, 0x72, 0x72, 0x61, 0x79, 0x73, 0x62, 0x06, 0x70, 0x72, 0x6f, 0x74,
	0x6f, 0x33,
}

var (
	file_arrays_array_service_proto_rawDescOnce sync.Once
	file_arrays_array_service_proto_rawDescData = file_arrays_array_service_proto_rawDesc
)

func file_arrays_array_service_proto_rawDescGZIP() []byte {
	file_arrays_array_service_proto_rawDescOnce.Do(func() {
		file_arrays_array_service_proto_rawDescData = protoimpl.X.CompressGZIP(file_arrays_array_service_proto_rawDescData)
	})
	return file_arrays_array_service_proto_rawDescData
}

var file_arrays_array_service_proto_msgTypes = make([]protoimpl.MessageInfo, 4)
var file_arrays_array_service_proto_goTypes = []interface{}{
	(*ReadRequest)(nil),           // 0: arrays.ReadRequest
	(*AppendRequest)(nil),         // 1: arrays.AppendRequest
	(*AppendMultipleRequest)(nil), // 2: arrays.AppendMultipleRequest
	(*ValueRequest)(nil),          // 3: arrays.ValueRequest
	(*data.IdRange)(nil),          // 4: data.IdRange
	(*data.Item)(nil),             // 5: data.Item
	(*emptypb.Empty)(nil),         // 6: google.protobuf.Empty
}
var file_arrays_array_service_proto_depIdxs = []int32{
	4, // 0: arrays.ReadRequest.range:type_name -> data.IdRange
	5, // 1: arrays.AppendRequest.item:type_name -> data.Item
	1, // 2: arrays.AppendMultipleRequest.ops:type_name -> arrays.AppendRequest
	0, // 3: arrays.Operator.Read:input_type -> arrays.ReadRequest
	1, // 4: arrays.Operator.Append:input_type -> arrays.AppendRequest
	2, // 5: arrays.Operator.AppendMultiple:input_type -> arrays.AppendMultipleRequest
	3, // 6: arrays.Operator.Value:input_type -> arrays.ValueRequest
	5, // 7: arrays.Operator.Read:output_type -> data.Item
	5, // 8: arrays.Operator.Append:output_type -> data.Item
	6, // 9: arrays.Operator.AppendMultiple:output_type -> google.protobuf.Empty
	5, // 10: arrays.Operator.Value:output_type -> data.Item
	7, // [7:11] is the sub-list for method output_type
	3, // [3:7] is the sub-list for method input_type
	3, // [3:3] is the sub-list for extension type_name
	3, // [3:3] is the sub-list for extension extendee
	0, // [0:3] is the sub-list for field type_name
}

func init() { file_arrays_array_service_proto_init() }
func file_arrays_array_service_proto_init() {
	if File_arrays_array_service_proto != nil {
		return
	}
	if !protoimpl.UnsafeEnabled {
		file_arrays_array_service_proto_msgTypes[0].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*ReadRequest); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_arrays_array_service_proto_msgTypes[1].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*AppendRequest); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_arrays_array_service_proto_msgTypes[2].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*AppendMultipleRequest); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_arrays_array_service_proto_msgTypes[3].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*ValueRequest); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_arrays_array_service_proto_rawDesc,
			NumEnums:      0,
			NumMessages:   4,
			NumExtensions: 0,
			NumServices:   1,
		},
		GoTypes:           file_arrays_array_service_proto_goTypes,
		DependencyIndexes: file_arrays_array_service_proto_depIdxs,
		MessageInfos:      file_arrays_array_service_proto_msgTypes,
	}.Build()
	File_arrays_array_service_proto = out.File
	file_arrays_array_service_proto_rawDesc = nil
	file_arrays_array_service_proto_goTypes = nil
	file_arrays_array_service_proto_depIdxs = nil
}
